program testjacobian

  use base
  use average
  use advect

  implicit none
  double precision :: pi
  double precision,allocatable  :: psi(:,:), f(:,:), dfdt(:,:)
  integer :: i,j 

!============================== ɸ ==============================
  call coordinates_init

  dt = 1e-3
  pi = atan(1.0d0)*4.0

  allocate( psi(nx,nz), f(nx,nz), dfdt(nx,nz) )

  !psi = sin(pi*xx)*sin(pi*zz)

  ! x,z 
  !psi = sin(2*pi*xx)*sin(2*pi*zz)
  !f = sin(2*pi*xx)
  !f = cos(2*pi*xx)
  !f = cos(2*pi*zz)

  ! x 
  psi = -zz
  !psi = (cos(2*pi*xx)+sin(2*pi*xx))*sin(pi*zz)
  !psi = sin(2*pi*xx)*sin(pi*zz)
  !f = ( cos(2*pi*xx) + sin(2*pi*xx) )
  !f = cos(2*pi*xx)
  f = ( cos(2*pi*xx) + sin(2*pi*xx) ) *sin(pi*zz)

  ! z 
  !psi = -xx
  !psi = sin(pi*xx)*cos(2*pi*zz)
  !f = cos(2*pi*zz)


  ! 2d box
  !psi = sin(pi*xx)*sin(pi*zz)
  !f = zz
  !f = xx

  !dfdt = jacobian_arakawa(psi,f)
  dfdt = jacobian_mpdata(psi,f)


  call gropn(1)
    call grfrm
    call grsvpt( 0.2, 0.8, 0.2, 0.8 )
    call sgswnd( real(x(1)), real(x(nx)), real(z(1)), real(z(nz)) )
    call grstrn( 1 )
    call grstrf
    call usdaxs
    !call uegtla( 0.0, 1.0, 0.02 ) 
    !call udgcla( 0.0, 1.0, 0.1 )
    call udcntr( real(psi), nx, nx, nz )

    call grfrm
    call grsvpt( 0.2, 0.8, 0.2, 0.8 )
    call sgswnd( real(x(1)), real(x(nx)), real(z(1)), real(z(nz)) )
    call grstrn( 1 )
    call grstrf
    call usdaxs
    !call uegtla( 0.0, 1.0, 0.02 ) 
    !call udgcla( 0.0, 1.0, 0.1 )
    call udcntr( real(f), nx, nx, nz )

    call grfrm
    call grsvpt( 0.2, 0.8, 0.2, 0.8 )
    call sgswnd( real(x(1)), real(x(nx)), real(z(1)), real(z(nz)) )
    call grstrn( 1 )
    call grstrf
    call usdaxs
    !call uegtla( 0.0, 1.0, 0.02 ) 
    !call udgcla( 0.0, 1.0, 0.1 )
    call udcntr( real(dfdt), nx, nx, nz )
    write(6,*) avr_xz(dfdt)
    !write(6,*) sum(dfdt)

    call grcls
    stop
  end program testjacobian
